package holeg.interfaces;

import java.util.LinkedList;

import holeg.utility.Vector2Float;

/**
 * Interface for all Elements that have a Graph to edit it state over time.
 * @author Tom Troppmann
 *
 */



public interface GraphEditable {
	/**
	 * all types of graphs
	 */
	public static enum GraphType {
		boolGraph, doubleGraph
	}
	/**
	 * Determine what type the Graph have.
	 * @return the type of the Graph
	 */
	GraphType getGraphType();
	/**
	 * Getter for the graph.
	 * @return The list of all graph points.
	 */
	LinkedList<Vector2Float> getStateGraph();
	
	/**
	 * Sample the Graph on the object.
	 */
	void sampleGraph();
	
	/**
	 * Resets the Graph two the initial start
	 * e.g. the Point Left and Right at 100%
	 */
	void reset();
}
