package holeg.ui.model;

import java.util.AbstractMap.SimpleEntry;
import java.util.HashSet;
import java.util.Set;

import com.google.gson.Gson;
import com.google.gson.GsonBuilder;

import holeg.adapter.AbstractCpsObjectAdapter;
import holeg.adapter.PairAdapter;
import holeg.adapter.PositionAdapter;
import holeg.model.AbstractCanvasObject;
import holeg.model.Edge;
import holeg.ui.view.main.Category;
import holeg.utility.Vector2Int;

public class GuiSettings {

    private static int pictureScale = 50; // Picture Scale
    private static int halfPictureScale = pictureScale / 2;
    public static Vector2Int canvasSize = new Vector2Int(3000,3000);
    
    
    public static int timerSpeed = 1000;
    public static boolean showSupplyBars = true;
    public static float maxCapacityForNewCreatedEdges = 10000;
    
    
    private static Set<Edge> selectedEdges = new HashSet<>();
    private static Set<Category> categories = new HashSet<>();
    private static Set<AbstractCanvasObject> clipboardObjects = new HashSet<>();
	private static Set<AbstractCanvasObject> selectedObjects = new HashSet<>();
    
	public static int autoSaveNr = -1;
    public static int numberOfSaves = 35;
    
    
    
    public static int getPictureScale() {
        return pictureScale;
    }

    public static int getPictureScaleDiv2() {
        return halfPictureScale;
    }
    public static void setPictureScale(int value) {
    	pictureScale = value;
    	halfPictureScale = (value + 1) / 2;
    }

    
	public static Set<Edge> getSelectedEdges() {
		return selectedEdges;
	}
	public static Set<Category> getCategories() {
		return categories;
	}
	public static Set<AbstractCanvasObject> getClipboardObjects() {
		return clipboardObjects;
	}
	public static void setClipboardObjects(Set<AbstractCanvasObject> clipboardObjects) {
		GuiSettings.clipboardObjects = clipboardObjects;
	}
	public static Set<AbstractCanvasObject> getSelectedObjects() {
		return selectedObjects;
	}
	public static void setSelectedObjects(Set<AbstractCanvasObject> selectedObjects) {
		GuiSettings.selectedObjects = selectedObjects;
	}
    
	
	//TODO(Tom2021-12-20) maybe moved somewhere else
    public static Gson gson = initGson();
    
    public static Gson initGson() {
        GsonBuilder builder = new GsonBuilder();
        builder.serializeNulls();
        builder.excludeFieldsWithoutExposeAnnotation();
        builder.setPrettyPrinting();
        builder.registerTypeAdapter(AbstractCanvasObject.class, new AbstractCpsObjectAdapter());
        builder.registerTypeAdapter(Vector2Int.class, new PositionAdapter());
        builder.registerTypeAdapter(SimpleEntry.class, new PairAdapter());
        return builder.create();
    }
}
