package holeg.utility;

public class Maths {
	private final static double EPSILON = 1E-6;
	
	public static double linearInterpolate(double first, double second, double alpha) {
		return first * (1.0 - alpha) + second * alpha;
	}
	
	public static double inverseLinearInterpolation(double min, double max, double value) {
		if (Math.abs(max - min) < EPSILON) return max;
		else return (value - min) / (max - min);
	}
}
